Index: code/trunk/src/modules/towerdefense/TowerDefenseTower.h
===================================================================
--- code/trunk/src/modules/towerdefense/TowerDefenseTower.h	(revision 10628)
+++ code/trunk/src/modules/towerdefense/TowerDefenseTower.h	(revision 10629)
@@ -19,5 +19,4 @@
 
 #include "towerdefense/TowerDefensePrereqs.h"
-#include "worldentities/pawns/SpaceShip.h"
 #include "objects/Turret.h"
 
@@ -38,10 +37,8 @@
 
         // Overriding these to stop TowerDefenseTowers from spasing out
-        /*
-        void setOrientation(const Quaternion& orientation);
-        virtual void rotateYaw(const Vector2& value);
-        virtual void rotatePitch(const Vector2& value);
-        virtual void rotateRoll(const Vector2& value);
-        */
+        //void setOrientation(const Quaternion& orientation);
+        //virtual void rotateYaw(const Vector2& value);
+        //virtual void rotatePitch(const Vector2& value);
+        //virtual void rotateRoll(const Vector2& value);
         virtual bool upgradeTower();
 
@@ -49,9 +46,7 @@
         void setGame(TowerDefense* Towerdefense)
         { assert(Towerdefense); game_ = Towerdefense; }
-        int upgrade;
-        int upgradeMax;
     private:
         TowerDefense* game_;
-
+        int upgrade;
     };
 }
Index: code/trunk/src/modules/weapons/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/weapons/CMakeLists.txt	(revision 10628)
+++ code/trunk/src/modules/weapons/CMakeLists.txt	(revision 10629)
@@ -2,4 +2,5 @@
   MuzzleFlash.cc
   RocketController.cc
+  IceGunFreezer.cc
 )
 
Index: code/trunk/src/modules/weapons/IceGunFreezer.cc
===================================================================
--- code/trunk/src/modules/weapons/IceGunFreezer.cc	(revision 10629)
+++ code/trunk/src/modules/weapons/IceGunFreezer.cc	(revision 10629)
@@ -0,0 +1,127 @@
+/*
+*   ORXONOX - the hottest 3D action shooter ever to exist
+*                    > www.orxonox.net <
+*
+*
+*   License notice:
+*
+*   This program is free software; you can redistribute it and/or
+*   modify it under the terms of the GNU General Public License
+*   as published by the Free Software Foundation; either version 2
+*   of the License, or (at your option) any later version.
+*
+*   This program is distributed in the hope that it will be useful,
+*   but WITHOUT ANY WARRANTY; without even the implied warranty of
+*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*   GNU General Public License for more details.
+*
+*   You should have received a copy of the GNU General Public License
+*   along with this program; if not, write to the Free Software
+*   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+*
+*   Author:
+*     Fabien Vultier
+*   Co-authors:
+*      ...
+*
+*/
+
+/**
+    @file IceGunFreezer.h
+    @brief Implementation of the IceGunFreezer class.
+*/
+
+#include "core/CoreIncludes.h"
+#include "core/command/Executor.h"
+
+#include "IceGunFreezer.h"
+
+namespace orxonox
+{
+    RegisterClass(IceGunFreezer);
+
+    /**
+    @brief
+        Constructor.
+    */
+    IceGunFreezer::IceGunFreezer(Context* context) : StaticEntity(context)
+    {
+        RegisterObject(IceGunFreezer);
+
+        model = new Model(this->getContext());
+        model->setMeshSource("IceStar.mesh");
+        model->setScale(4.0);
+        this->attach(model);
+        model->setPosition(Vector3(0,0,0));
+    }
+
+    IceGunFreezer::~IceGunFreezer()
+    {
+
+    }
+
+    /**
+    @brief
+        The controlling happens here. This method defines what the controller has to do each tick.
+    @param dt
+        The duration of the tick.
+    */
+    void IceGunFreezer::tick(float dt)
+    {
+        SUPER(IceGunFreezer, tick, dt);
+
+
+    }
+
+    /**
+    @brief
+        Sets the freeze time variable to the passed value.
+    */
+    void IceGunFreezer::setFreezeTime(float freezeTime)
+    {
+        freezeTime_ = freezeTime;
+    }
+
+    /**
+    @brief
+        Sets the freeze factor variable to the passed value.
+    */
+    void IceGunFreezer::setFreezeFactor(float freezeFactor)
+    {
+        freezeFactor_ = freezeFactor;
+    }    
+
+    /**
+    @brief
+        Try to slow down the WorldEntity where this is attached to. It is only possible to slow down a SpaceShip.
+    */
+    void IceGunFreezer::startFreezing()
+    {
+        WorldEntity* parent = this->getParent();
+
+        // Check if the freezer is attached to a parent and check if the parent is a SpaceShip
+        if (parent != NULL && parent->isA(Class(SpaceShip)))
+        {
+            freezedSpaceShip_ = orxonox_cast<SpaceShip*>(parent);
+            //Slow down the SpaceShip
+            freezedSpaceShip_->addSpeedFactor(freezeFactor_);
+        }
+
+        // Start timer even if the victim is not a SpaceShip to avoid that the IceGunFreezer gets never destroyed if it collided against a Pawn
+        this->freezeTimer_.setTimer(this->freezeTime_, false, createExecutor(createFunctor(&IceGunFreezer::stopFreezing, this)));
+    }
+
+    /**
+    @brief
+        This method is called by the timer. It gives back the original engine strength to the hit SpaceShip.
+    */
+    void IceGunFreezer::stopFreezing()
+    {
+        if (freezedSpaceShip_ != NULL && freezeFactor_ != 0.0)
+        {
+            freezedSpaceShip_->addSpeedFactor(1/freezeFactor_);
+        }
+
+        this->destroy();
+    }    
+}
Index: code/trunk/src/modules/weapons/IceGunFreezer.h
===================================================================
--- code/trunk/src/modules/weapons/IceGunFreezer.h	(revision 10629)
+++ code/trunk/src/modules/weapons/IceGunFreezer.h	(revision 10629)
@@ -0,0 +1,71 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceGunFreezer.h
+    @brief Definition of the IceGunFreezer class.
+*/
+
+#ifndef _IceGunFreezer_H__
+#define _IceGunFreezer_H__
+
+#include "weapons/WeaponsPrereqs.h"
+
+#include "tools/interfaces/Tickable.h"
+#include "worldentities/StaticEntity.h"
+#include "graphics/Model.h"
+#include "tools/Timer.h"  
+#include "worldentities/pawns/SpaceShip.h"  
+
+namespace orxonox
+{
+    /**
+    @brief
+        This is the WorldEntity that gets attached to a victim hit by a IceGunProjectile. It slows down the hit SpaceShip by a defined amount and time.
+    @ingroup Weapons
+    */
+    class _WeaponsExport IceGunFreezer : public StaticEntity, public Tickable
+    {
+        public:
+            IceGunFreezer(Context* context);
+            virtual ~IceGunFreezer();
+            virtual void tick(float dt);
+            virtual void startFreezing();
+            virtual void stopFreezing();
+            virtual void setFreezeTime(float freezeTime);
+            virtual void setFreezeFactor(float freezeFactor);
+        private:
+            float freezeTime_; //The duration of the freezing effect on a target
+            float freezeFactor_; //The strength of the freezing effect            
+            Model* model;
+            Timer freezeTimer_;
+            WeakPtr<SpaceShip> freezedSpaceShip_;
+    };
+}
+
+#endif /* _IceGunFreezer_H__ */
Index: code/trunk/src/modules/weapons/munitions/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/weapons/munitions/CMakeLists.txt	(revision 10628)
+++ code/trunk/src/modules/weapons/munitions/CMakeLists.txt	(revision 10629)
@@ -5,3 +5,5 @@
   RocketMunition.cc
   GravityBombMunition.cc
+  IceMunition.cc
+  SplitMunition.cc
 )
Index: code/trunk/src/modules/weapons/munitions/IceMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/IceMunition.cc	(revision 10629)
+++ code/trunk/src/modules/weapons/munitions/IceMunition.cc	(revision 10629)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceMunition.h
+    @brief Implementation of the IceMunition class.
+*/
+
+#include "IceMunition.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    RegisterClass(IceMunition);
+
+    IceMunition::IceMunition(Context* context) : Munition(context)
+    {
+        RegisterObject(IceMunition);
+
+        this->maxMunitionPerMagazine_ = 1;
+        this->maxMagazines_ = 50;
+        this->magazines_ = 25;
+
+        this->bUseSeparateMagazines_ = false;
+        this->bStackMunition_ = true;
+
+        this->bAllowMunitionRefilling_ = false;
+        this->bAllowMultiMunitionRemovementUnderflow_ = false;
+    }
+}
Index: code/trunk/src/modules/weapons/munitions/IceMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/IceMunition.h	(revision 10629)
+++ code/trunk/src/modules/weapons/munitions/IceMunition.h	(revision 10629)
@@ -0,0 +1,58 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceMunition.h
+    @brief Definition of the IceMunition class.
+*/
+
+#ifndef _IceMunition_H__
+#define _IceMunition_H__
+
+#include "weapons/WeaponsPrereqs.h"
+#include "weaponsystem/Munition.h"
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        IceMunition.
+    @author
+        Fabien Vultier
+    @ingroup WeaponsMunitions
+    */
+    class _WeaponsExport IceMunition : public Munition
+    {
+        public:
+            IceMunition(Context* context);
+            virtual ~IceMunition() {}
+    };
+}
+
+#endif /* _SplitMunition_H__ */
Index: code/trunk/src/modules/weapons/munitions/SplitMunition.cc
===================================================================
--- code/trunk/src/modules/weapons/munitions/SplitMunition.cc	(revision 10629)
+++ code/trunk/src/modules/weapons/munitions/SplitMunition.cc	(revision 10629)
@@ -0,0 +1,55 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file SplitMunition.h
+    @brief Implementation of the SplitMunition class.
+*/
+
+#include "SplitMunition.h"
+#include "core/CoreIncludes.h"
+
+namespace orxonox
+{
+    RegisterClass(SplitMunition);
+
+    SplitMunition::SplitMunition(Context* context) : Munition(context)
+    {
+        RegisterObject(SplitMunition);
+
+        this->maxMunitionPerMagazine_ = 1;
+        this->maxMagazines_ = 100;
+        this->magazines_ = 25;
+
+        this->bUseSeparateMagazines_ = false;
+        this->bStackMunition_ = true;
+
+        this->bAllowMunitionRefilling_ = true;
+        this->bAllowMultiMunitionRemovementUnderflow_ = false;
+    }
+}
Index: code/trunk/src/modules/weapons/munitions/SplitMunition.h
===================================================================
--- code/trunk/src/modules/weapons/munitions/SplitMunition.h	(revision 10629)
+++ code/trunk/src/modules/weapons/munitions/SplitMunition.h	(revision 10629)
@@ -0,0 +1,58 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file SplitMunition.h
+    @brief Definition of the SplitMunition class.
+*/
+
+#ifndef _SplitMunition_H__
+#define _SplitMunition_H__
+
+#include "weapons/WeaponsPrereqs.h"
+#include "weaponsystem/Munition.h"
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        SplitMunition.
+    @author
+        Fabien Vultier
+    @ingroup WeaponsMunitions
+    */
+    class _WeaponsExport SplitMunition : public Munition
+    {
+        public:
+            SplitMunition(Context* context);
+            virtual ~SplitMunition() {}
+    };
+}
+
+#endif /* _SplitMunition_H__ */
Index: code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 10628)
+++ code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 10629)
@@ -88,4 +88,15 @@
     /**
     @brief
+        Get the material of the BillboardProjectile.
+    @return
+        The material name.
+    */
+    const std::string& BillboardProjectile::getMaterial()
+    {
+        return this->billboard_.getMaterial();
+    }
+
+    /**
+    @brief
         Is called when the visibility of the BillboardProjectile has changed.
     */
Index: code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 10628)
+++ code/trunk/src/modules/weapons/projectiles/BillboardProjectile.h	(revision 10629)
@@ -60,4 +60,5 @@
             virtual void setColour(const ColourValue& colour);
             virtual void setMaterial(const std::string& material);
+            virtual const std::string& getMaterial();
             virtual void changedVisibility();
 
Index: code/trunk/src/modules/weapons/projectiles/CMakeLists.txt
===================================================================
--- code/trunk/src/modules/weapons/projectiles/CMakeLists.txt	(revision 10628)
+++ code/trunk/src/modules/weapons/projectiles/CMakeLists.txt	(revision 10629)
@@ -5,4 +5,6 @@
   Projectile.cc
   LightningGunProjectile.cc
+  SplitGunProjectile.cc
+  IceGunProjectile.cc
   Rocket.cc
   RocketOld.cc
Index: code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 10629)
+++ code/trunk/src/modules/weapons/projectiles/IceGunProjectile.cc	(revision 10629)
@@ -0,0 +1,98 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceGunProjectile.cc
+    @brief Implementation of the IceGunProjectile class.
+*/
+
+#include "IceGunProjectile.h"
+
+#include "core/CoreIncludes.h"
+#include "graphics/Model.h"
+
+namespace orxonox
+{
+    RegisterClass(IceGunProjectile);
+
+    IceGunProjectile::IceGunProjectile(Context* context) : Projectile(context)
+    {
+        RegisterObject(IceGunProjectile);
+
+        this->setCollisionShapeRadius(8.0f);
+
+        this->setFreezeTime(3.0);
+        this->setFreezeFactor(0.5);
+
+        Model* model = new Model(this->getContext());
+        model->setMeshSource("IceBolt.mesh");
+        model->setScale(15.0);
+        this->attach(model);
+        model->setPosition(Vector3(0,0,0));
+    }
+
+    /**
+    @brief
+        Sets the freeze time variable to the passed value.
+    */
+    void IceGunProjectile::setFreezeTime(float freezeTime)
+    {
+        freezeTime_ = freezeTime;
+    }
+
+    /**
+    @brief
+        Sets the freeze factor variable to the passed value.
+    */
+    void IceGunProjectile::setFreezeFactor(float freezeFactor)
+    {
+        freezeFactor_ = freezeFactor;
+    }
+
+    bool IceGunProjectile::collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint)
+    {        
+        bool bCollision = Projectile::collidesAgainst(otherObject, cs, contactPoint);
+
+        if (bCollision)
+        {
+            // If there was a collision, attach a IceGunFreezer to the hit object.
+            IceGunFreezer* freezer = new IceGunFreezer(this->getContext());
+            freezer->setFreezeTime(freezeTime_);
+            freezer->setFreezeFactor(freezeFactor_);
+            otherObject->attach(freezer);            
+
+            Vector3 offset = this->getWorldPosition() - otherObject->getWorldPosition();
+            freezer->setPosition(Vector3(0,0,0));
+            freezer->translate(offset, WorldEntity::World);
+            // Start the freezing effect.
+            freezer->startFreezing();
+        }
+
+        return bCollision;
+    }
+}
Index: code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h	(revision 10629)
+++ code/trunk/src/modules/weapons/projectiles/IceGunProjectile.h	(revision 10629)
@@ -0,0 +1,71 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabien Vultier
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+    @file IceGunProjectile.h
+    @brief Definition of the IceGunProjectile class.
+*/
+
+#ifndef _IceGunProjectile_H__
+#define _IceGunProjectile_H__
+
+#include "weapons/WeaponsPrereqs.h"
+
+#include <string>
+#include "tools/Timer.h"
+#include "BillboardProjectile.h"
+#include "weapons/IceGunFreezer.h"
+
+namespace orxonox
+{
+
+    /**
+    @brief
+        The IceGunProjectile is a projectile that attaches a IceGunFreezer to the hit object. This object gets slowed down by the IceGunFreezer.
+    @author
+        Fabien Vultier
+    @ingroup WeaponsProjectiles
+    */
+    class _WeaponsExport IceGunProjectile : public Projectile
+    {
+        public:
+            IceGunProjectile(Context* context);
+            virtual ~IceGunProjectile() {}
+
+            virtual void setFreezeTime(float freezeTime);
+            virtual void setFreezeFactor(float freezeFactor);
+
+        protected:
+            virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
+        private:         
+            float freezeTime_; //The duration of the freezing effect on a target
+            float freezeFactor_; //The strength of the freezing effect
+    };
+}
+
+#endif /* _IceGunProjectile_H__ */
Index: code/trunk/src/modules/weapons/projectiles/Projectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 10628)
+++ code/trunk/src/modules/weapons/projectiles/Projectile.cc	(revision 10629)
@@ -39,5 +39,4 @@
 #include "core/command/Executor.h"
 
-#include "objects/collisionshapes/SphereCollisionShape.h"
 #include "worldentities/pawns/Pawn.h"
 
@@ -60,7 +59,8 @@
             this->setCollisionType(Dynamic);
 
-            SphereCollisionShape* shape = new SphereCollisionShape(this->getContext());
-            shape->setRadius(20.0f);
-            this->attachCollisionShape(shape);
+            // Create a sphere collision shape and attach it to the projectile.
+            collisionShape_ = new SphereCollisionShape(this->getContext());
+            setCollisionShapeRadius(20.0f);
+            this->attachCollisionShape(collisionShape_);
 
             this->destroyTimer_.setTimer(this->lifetime_, false, createExecutor(createFunctor(&BasicProjectile::destroyObject, this)));
@@ -76,5 +76,4 @@
         SetConfigValue(lifetime_, 4.0f).description("The time in seconds a projectile stays alive");
     }
-
 
     void Projectile::tick(float dt)
@@ -93,3 +92,10 @@
     }
 
+    void Projectile::setCollisionShapeRadius(float radius)
+    {
+        if (collisionShape_ != NULL && radius > 0)
+        {
+            collisionShape_->setRadius(radius);
+        }        
+    }
 }
Index: code/trunk/src/modules/weapons/projectiles/Projectile.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 10628)
+++ code/trunk/src/modules/weapons/projectiles/Projectile.h	(revision 10629)
@@ -39,4 +39,5 @@
 #include "tools/Timer.h"
 #include "worldentities/MovableEntity.h"
+#include "objects/collisionshapes/SphereCollisionShape.h"
 
 #include "BasicProjectile.h"
@@ -66,7 +67,11 @@
             virtual bool collidesAgainst(WorldEntity* otherObject, const btCollisionShape* cs, btManifoldPoint& contactPoint);
 
+        protected:
+            virtual void setCollisionShapeRadius(float radius);
+
         private:
             float lifetime_; //!< The time the projectile exists.
             Timer destroyTimer_; //!< Timer to destroy the projectile after its lifetime has run out.
+            WeakPtr<SphereCollisionShape> collisionShape_; // The collision shape of the projectile.            
     };
 }
